commit:     5fec07c1189e779dfb1c9ec2bfd148871c49297b
Author:     Sam James <sam <AT> gentoo <DOT> org>
AuthorDate: Fri Jun 17 17:55:06 2022 +0000
Commit:     Sam James <sam <AT> gentoo <DOT> org>
CommitDate: Fri Jun 17 17:55:14 2022 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=5fec07c1

dev-db/mongodb: fix build with Boost 1.79 for 4.2.17

Closes: https://bugs.gentoo.org/843290
Signed-off-by: Sam James <sam <AT> gentoo.org>

 .../mongodb/files/mongodb-4.2.17-boost-1.79.patch  |  41 +++++
 dev-db/mongodb/files/mongodb-4.4.1-boost.patch     |   2 -
 .../mongodb/files/mongodb-4.4.10-boost-1.79.patch  |  15 +-
 dev-db/mongodb/mongodb-4.2.17-r2.ebuild            | 182 +++++++++++++++++++++
 4 files changed, 224 insertions(+), 16 deletions(-)

diff --git a/dev-db/mongodb/files/mongodb-4.2.17-boost-1.79.patch 
b/dev-db/mongodb/files/mongodb-4.2.17-boost-1.79.patch
new file mode 100644
index 000000000000..b86efa142f5c
--- /dev/null
+++ b/dev-db/mongodb/files/mongodb-4.2.17-boost-1.79.patch
@@ -0,0 +1,41 @@
+https://bugs.gentoo.org/844235
+--- a/src/mongo/util/processinfo_linux.cpp
++++ b/src/mongo/util/processinfo_linux.cpp
+@@ -51,6 +51,7 @@
+ #endif
+ 
+ #include <boost/filesystem.hpp>
++#include <boost/filesystem/fstream.hpp>
+ #include <boost/none.hpp>
+ #include <boost/optional.hpp>
+ #include <fmt/format.h>
+--- a/src/mongo/db/storage/wiredtiger/wiredtiger_util.cpp
++++ b/src/mongo/db/storage/wiredtiger/wiredtiger_util.cpp
+@@ -36,6 +36,7 @@
+ #include <limits>
+ 
+ #include <boost/filesystem.hpp>
++#include <boost/filesystem/fstream.hpp>
+ #include <boost/filesystem/path.hpp>
+ 
+ #include "mongo/base/simple_string_data_comparator.h"
+--- a/src/mongo/shell/shell_utils_extended.cpp
++++ b/src/mongo/shell/shell_utils_extended.cpp
+@@ -37,6 +37,7 @@
+ #endif
+ 
+ #include <boost/filesystem.hpp>
++#include <boost/filesystem/fstream.hpp>
+ #include <fstream>
+ 
+ #include "mongo/scripting/engine.h"
+--- a/src/mongo/db/storage/storage_repair_observer.cpp
++++ b/src/mongo/db/storage/storage_repair_observer.cpp
+@@ -41,6 +41,7 @@
+ #include <sys/types.h>
+ #endif
+ 
++#include <boost/filesystem/fstream.hpp>
+ #include <boost/filesystem/path.hpp>
+ 
+ #include "mongo/db/dbhelpers.h"

diff --git a/dev-db/mongodb/files/mongodb-4.4.1-boost.patch 
b/dev-db/mongodb/files/mongodb-4.4.1-boost.patch
index 009ca6826a4f..d14f6fe3052f 100644
--- a/dev-db/mongodb/files/mongodb-4.4.1-boost.patch
+++ b/dev-db/mongodb/files/mongodb-4.4.1-boost.patch
@@ -1,5 +1,3 @@
-diff --git a/SConstruct b/SConstruct
-index 89c044ab..0484e475 100644
 --- a/SConstruct
 +++ b/SConstruct
 @@ -3511,17 +3511,11 @@ def doConfigure(myenv):

diff --git a/dev-db/mongodb/files/mongodb-4.4.10-boost-1.79.patch 
b/dev-db/mongodb/files/mongodb-4.4.10-boost-1.79.patch
index df7dbc001b05..601141e8d416 100644
--- a/dev-db/mongodb/files/mongodb-4.4.10-boost-1.79.patch
+++ b/dev-db/mongodb/files/mongodb-4.4.10-boost-1.79.patch
@@ -1,5 +1,4 @@
-diff --git a/src/mongo/db/auth/security_key_test.cpp 
b/src/mongo/db/auth/security_key_test.cpp
-index fc1787b5..70b977c1 100644
+https://bugs.gentoo.org/844235
 --- a/src/mongo/db/auth/security_key_test.cpp
 +++ b/src/mongo/db/auth/security_key_test.cpp
 @@ -30,6 +30,7 @@
@@ -10,8 +9,6 @@ index fc1787b5..70b977c1 100644
  
  #include "mongo/base/string_data.h"
  #include "mongo/db/auth/authorization_manager.h"
-diff --git a/src/mongo/db/storage/storage_repair_observer.cpp 
b/src/mongo/db/storage/storage_repair_observer.cpp
-index 22b76a6a..ec5bcece 100644
 --- a/src/mongo/db/storage/storage_repair_observer.cpp
 +++ b/src/mongo/db/storage/storage_repair_observer.cpp
 @@ -41,6 +41,7 @@
@@ -22,8 +19,6 @@ index 22b76a6a..ec5bcece 100644
  #include <boost/filesystem/path.hpp>
  
  #include "mongo/db/dbhelpers.h"
-diff --git a/src/mongo/db/storage/wiredtiger/wiredtiger_kv_engine_test.cpp 
b/src/mongo/db/storage/wiredtiger/wiredtiger_kv_engine_test.cpp
-index 01bb7806..78c15609 100644
 --- a/src/mongo/db/storage/wiredtiger/wiredtiger_kv_engine_test.cpp
 +++ b/src/mongo/db/storage/wiredtiger/wiredtiger_kv_engine_test.cpp
 @@ -34,6 +34,7 @@
@@ -34,8 +29,6 @@ index 01bb7806..78c15609 100644
  #include <boost/filesystem/path.hpp>
  #include <memory>
  
-diff --git a/src/mongo/db/storage/wiredtiger/wiredtiger_util.cpp 
b/src/mongo/db/storage/wiredtiger/wiredtiger_util.cpp
-index 58e85385..0f8a5148 100644
 --- a/src/mongo/db/storage/wiredtiger/wiredtiger_util.cpp
 +++ b/src/mongo/db/storage/wiredtiger/wiredtiger_util.cpp
 @@ -36,6 +36,7 @@
@@ -46,8 +39,6 @@ index 58e85385..0f8a5148 100644
  #include <boost/filesystem/path.hpp>
  
  #include "mongo/base/simple_string_data_comparator.h"
-diff --git a/src/mongo/shell/shell_utils_extended.cpp 
b/src/mongo/shell/shell_utils_extended.cpp
-index 8cd7f035..cd672eb5 100644
 --- a/src/mongo/shell/shell_utils_extended.cpp
 +++ b/src/mongo/shell/shell_utils_extended.cpp
 @@ -37,6 +37,7 @@
@@ -58,8 +49,6 @@ index 8cd7f035..cd672eb5 100644
  #include <fstream>
  
  #include "mongo/bson/bson_validate.h"
-diff --git a/src/mongo/util/processinfo_linux.cpp 
b/src/mongo/util/processinfo_linux.cpp
-index de4b84bc..b01fa7a2 100644
 --- a/src/mongo/util/processinfo_linux.cpp
 +++ b/src/mongo/util/processinfo_linux.cpp
 @@ -36,6 +36,7 @@
@@ -70,8 +59,6 @@ index de4b84bc..b01fa7a2 100644
  #include <sched.h>
  #include <stdio.h>
  #include <sys/mman.h>
-diff --git a/src/mongo/util/stacktrace_threads.cpp 
b/src/mongo/util/stacktrace_threads.cpp
-index 4667a261..73a36015 100644
 --- a/src/mongo/util/stacktrace_threads.cpp
 +++ b/src/mongo/util/stacktrace_threads.cpp
 @@ -36,6 +36,7 @@

diff --git a/dev-db/mongodb/mongodb-4.2.17-r2.ebuild 
b/dev-db/mongodb/mongodb-4.2.17-r2.ebuild
new file mode 100644
index 000000000000..7d281ed16289
--- /dev/null
+++ b/dev-db/mongodb/mongodb-4.2.17-r2.ebuild
@@ -0,0 +1,182 @@
+# Copyright 1999-2022 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+PYTHON_COMPAT=( python3_{7..10} )
+
+SCONS_MIN_VERSION="2.5.0"
+CHECKREQS_DISK_BUILD="2400M"
+CHECKREQS_DISK_USR="512M"
+CHECKREQS_MEMORY="1024M"
+
+inherit check-reqs flag-o-matic multiprocessing pax-utils python-any-r1 
scons-utils systemd toolchain-funcs
+
+MY_P=${PN}-src-r${PV/_rc/-rc}
+
+DESCRIPTION="A high-performance, open source, schema-free document-oriented 
database"
+HOMEPAGE="https://www.mongodb.com";
+SRC_URI="https://fastdl.mongodb.org/src/${MY_P}.tar.gz";
+
+LICENSE="Apache-2.0 SSPL-1"
+SLOT="0"
+KEYWORDS="~amd64 ~arm64"
+IUSE="debug kerberos lto ssl test +tools"
+RESTRICT="!test? ( test )"
+
+RDEPEND="acct-group/mongodb
+       acct-user/mongodb
+       >=app-arch/snappy-1.1.3:=
+       >=dev-cpp/yaml-cpp-0.6.2:=
+       >=dev-libs/boost-1.70:=[threads(+)]
+       >=dev-libs/libpcre-8.42[cxx]
+       app-arch/zstd:=
+       dev-libs/snowball-stemmer:=
+       net-libs/libpcap
+       >=sys-libs/zlib-1.2.11:=
+       kerberos? ( dev-libs/cyrus-sasl[kerberos] )
+       ssl? (
+               >=dev-libs/openssl-1.0.1g:0=
+       )"
+DEPEND="${RDEPEND}
+       ${PYTHON_DEPS}
+       $(python_gen_any_dep '
+               test? ( dev-python/pymongo[${PYTHON_USEDEP}] 
dev-python/requests[${PYTHON_USEDEP}] )
+               >=dev-util/scons-2.5.0[${PYTHON_USEDEP}]
+               dev-python/cheetah3[${PYTHON_USEDEP}]
+               dev-python/psutil[${PYTHON_USEDEP}]
+               dev-python/pyyaml[${PYTHON_USEDEP}]
+       ')
+       sys-libs/ncurses:0=
+       sys-libs/readline:0=
+       debug? ( dev-util/valgrind )"
+PDEPEND="tools? ( >=app-admin/mongo-tools-${PV} )"
+
+PATCHES=(
+       "${FILESDIR}/${PN}-4.2.0-fix-scons.patch"
+       "${FILESDIR}/${PN}-4.4.1-gcc11.patch"
+       "${FILESDIR}/${PN}-4.2.15-no-compass.patch"
+       "${FILESDIR}/${PN}-5.0.2-glibc-2.34.patch"
+       "${FILESDIR}/${PN}-4.2.17-boost-1.79.patch"
+)
+
+S="${WORKDIR}/${MY_P}"
+
+python_check_deps() {
+       if use test; then
+               has_version "dev-python/pymongo[${PYTHON_USEDEP}]" || return 1
+               has_version "dev-python/requests[${PYTHON_USEDEP}]" || return 1
+       fi
+
+       has_version ">=dev-util/scons-2.5.0[${PYTHON_USEDEP}]" &&
+       has_version "dev-python/cheetah3[${PYTHON_USEDEP}]" &&
+       has_version "dev-python/psutil[${PYTHON_USEDEP}]" &&
+       has_version "dev-python/pyyaml[${PYTHON_USEDEP}]"
+}
+
+pkg_pretend() {
+       if [[ -n ${REPLACING_VERSIONS} ]]; then
+               if ver_test "$REPLACING_VERSIONS" -lt 4.0; then
+                       ewarn "To upgrade from a version earlier than the 
4.0-series, you must"
+                       ewarn "successively upgrade major releases until you 
have upgraded"
+                       ewarn "to 4.0-series. Then upgrade to 4.2 series."
+               else
+                       ewarn "Be sure to set featureCompatibilityVersion to 
4.0 before upgrading."
+               fi
+       fi
+}
+
+src_prepare() {
+       default
+
+       # remove bundled libs
+       rm -r 
src/third_party/{boost-*,pcre-*,scons-*,snappy-*,yaml-cpp-*,zlib-*,zstandard-*} 
|| die
+
+       # remove compass
+       rm -r src/mongo/installer/compass || die
+}
+
+src_configure() {
+       # https://github.com/mongodb/mongo/wiki/Build-Mongodb-From-Source
+       # --use-system-icu fails tests
+       # --use-system-tcmalloc is strongly NOT recommended:
+       scons_opts=(
+               AR="$(tc-getAR)"
+               CC="$(tc-getCC)"
+               CXX="$(tc-getCXX)"
+
+               --disable-warnings-as-errors
+               --use-system-boost
+               --use-system-pcre
+               --use-system-snappy
+               --use-system-stemmer
+               --use-system-yaml
+               --use-system-zlib
+               --use-system-zstd
+       )
+
+       use arm64 && scons_opts+=( --use-hardware-crc32=off ) # Bug 701300
+       use debug && scons_opts+=( --dbg=on )
+       use kerberos && scons_opts+=( --use-sasl-client )
+       use lto && scons_opts+=( --lto=on )
+       use ssl && scons_opts+=( --ssl )
+
+       # Needed to avoid forcing FORTIFY_SOURCE
+       # Gentoo's toolchain applies these anyway
+       scons_opts+=( --runtime-hardening=off )
+
+       # respect mongoDB upstream's basic recommendations
+       # see bug #536688 and #526114
+       if ! use debug; then
+               filter-flags '-m*'
+               filter-flags '-O?'
+       fi
+
+       default
+}
+
+src_compile() {
+       escons "${scons_opts[@]}" core tools
+}
+
+# FEATURES="test -usersandbox" emerge dev-db/mongodb
+src_test() {
+       ewarn "Tests may hang with FEATURES=usersandbox"
+       "${EPYTHON}" ./buildscripts/resmoke.py run --dbpathPrefix=test --suites 
core --jobs=$(makeopts_jobs) || die "Tests failed with ${EPYTHON}"
+}
+
+src_install() {
+       escons "${scons_opts[@]}" --nostrip install --prefix="${ED}"/usr
+
+       doman debian/mongo*.1
+       dodoc README docs/building.md
+
+       newinitd "${FILESDIR}/${PN}.initd-r3" ${PN}
+       newconfd "${FILESDIR}/${PN}.confd-r3" ${PN}
+       newinitd "${FILESDIR}/mongos.initd-r3" mongos
+       newconfd "${FILESDIR}/mongos.confd-r3" mongos
+
+       insinto /etc
+       newins "${FILESDIR}/${PN}.conf-r3" ${PN}.conf
+       newins "${FILESDIR}/mongos.conf-r2" mongos.conf
+
+       systemd_newunit "${FILESDIR}/${PN}.service-r1" "${PN}.service"
+
+       insinto /etc/logrotate.d/
+       newins "${FILESDIR}/${PN}.logrotate" ${PN}
+
+       # see bug #526114
+       pax-mark emr "${ED}"/usr/bin/{mongo,mongod,mongos}
+
+       local x
+       for x in /var/{lib,log}/${PN}; do
+               diropts -m0750 -o mongodb -g mongodb
+               keepdir "${x}"
+       done
+}
+
+pkg_postinst() {
+       ewarn "Make sure to read the release notes and follow the upgrade 
process:"
+       ewarn "  https://docs.mongodb.com/manual/release-notes/$(ver_cut 1-2)/"
+       ewarn "  https://docs.mongodb.com/manual/release-notes/$(ver_cut 
1-2)/#upgrade-procedures"
+}

Reply via email to